package RalliJava;

/**
 * @author idamk
 * @version 12.2.2025
 *
 */
public class Henkilot {
    
    private static final int MAX_HENKILOT = 5;

    int lkm = 0;
    private Henkilo[] alkiot;

    
    /**
     *  luodaan alustava taulukko
     */
    public Henkilot() {
        this.alkiot = new Henkilo[MAX_HENKILOT];
    }
    
    
    /**
     * @param henkilo lisättävä henkilö
     * @throws SailoException säilö
     */
    public void lisaa(Henkilo henkilo) throws SailoException {
        if (lkm >= alkiot.length) throw new SailoException("Liikaa alkioita");
        this.alkiot[this.lkm] = henkilo;
        this.lkm++;
    }


    /**
     * @return lkm
     */
    public int getLkm() {
        return lkm;
    }
    
    
    /**
     * @param i indeksi
     * @return henkilön
     * @throws IndexOutOfBoundsException laiton indeksi
     */
    public Henkilo anna(int i) throws IndexOutOfBoundsException {
        if (i < 0 || this.lkm <= i)
                throw new IndexOutOfBoundsException("Laiton indeksi senkin kaulin: " + i);
        return alkiot[i];
    }
    
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Henkilot henkilot = new Henkilot();
        
        try {
            Henkilo rovis = new Henkilo();
            Henkilo asunmaa = new Henkilo();
            Henkilo elfyn = new Henkilo();
            rovis.rekisteroi();
            rovis.vastaahlo();
            asunmaa.rekisteroi();
            asunmaa.vastaahlo();
            elfyn.rekisteroi();
            elfyn.vastaahlo();
            
            henkilot.lisaa(rovis);
            henkilot.lisaa(asunmaa);
            henkilot.lisaa(elfyn);
            } catch (SailoException e) {
                System.err.println("Liikaa alkioita :0"); //kun alkioita enemmän kun MAX sallii
            }
        

    }

}
