package RalliJava;

/**
 * @author idamk
 * @version 25.2.2025
 *
 */
public class Rekisteri {

    private final Henkilot henkilot = new Henkilot();
    
    
    /**
     * @return lkm
     */
    public int getHenkiloita() {
        return henkilot.getLkm();
    }
    
    
    /**
     * Lisää uuden henkilön
     * @param henkilo lisättävä
     * @throws SailoException liikaa alkioita
     */
    public void lisaa (Henkilo henkilo) throws SailoException{
        henkilot.lisaa(henkilo);
    }
    
    
    /**
     * @param i indeksi
     * @return henkilön tiedot
     */
    public Henkilo annaHenkilo(int i) {
        return henkilot.anna(i);  
    }
    
    
    /**
     * @param args ei käytössä
     * @throws SailoException liikaa
     */
    public static void main(String[] args) throws SailoException {
        Rekisteri rekisteri = new Rekisteri();
        
        try {
            Henkilo rovis = new Henkilo();
            Henkilo asunmaa = new Henkilo();
            Henkilo elfyn = new Henkilo();
            rovis.rekisteroi();
            rovis.vastaahlo();
            asunmaa.rekisteroi();
            asunmaa.vastaahlo();
            elfyn.rekisteroi();
            elfyn.vastaahlo();
            
            rekisteri.lisaa(rovis);
            rekisteri.lisaa(asunmaa);
            rekisteri.lisaa(elfyn);
            } catch (SailoException e) {
                System.err.println("Liikaa alkioita :("); //kun alkioita enemmän kun MAX sallii
            }
        
        for (int i=0; i<rekisteri.getHenkiloita(); i++) {
            Henkilo henkilo = rekisteri.annaHenkilo(i);
            henkilo.tulosta(System.out);
        } 
        
        int lkm = rekisteri.getHenkiloita();
        System.out.println("Henkilöitä on nyt " + lkm + "!");
        
    }



}
